#
# $Header: /scratch/fock/cvsroot/xd/xdgraph/tcl/guiObjectsMenu.tcl,v 1.2 1996/09/06 12:50:40 richter Rel $
#
#
# $Log: guiObjectsMenu.tcl,v $
# Revision 1.2  1996/09/06 12:50:40  richter
# mark active objects
#
# Revision 1.1  1996/05/23  07:42:21  richter
# Initial revision
#
#

proc guiObjectsMenu {w} {
    global xd_tk_major
 
    menubutton $w -text Objects -underline 0 -menu $w.menu 
    menu $w.menu -postcommand [list rebuild_object_menu $w.menu]
    if {$xd_tk_major >= 4} {
	$w.menu configure -tearoff off
    }
}
proc add_object_entry {w name type} {
    global active

    set m $w.$name
    if {[string compare $active($type) $name] == 0} {
	set label "$name* ($type)"
    } else {
	set label "$name ($type)"
    }
    $w add cascade -label $label -menu $m
    if {![winfo exists $m]} {
#Cljf remove default tearoff property of menu
#        menu $m  
        menu $m  -tearoff off
	$m add command -label "set active $type" \
	    -command "set active($type) $name"
	$m add command -label "info" -command "doCommand \"$name info\""
	$m add command -label "remove" -command "doCommand \"$name remove\""
	if {[string compare $type dataset]} {
	    $m add command -label "configure ..." \
		-command "guiConfigure $type $name"
	    $m add command -label "plot" -command "doCommand \"$name plot\""
	    $m add command -label "clear" -command "doCommand \"$name clear\""
	}
    }
}

proc rebuild_object_menu {w} {
    global xd_tk_major

    set last [$w index last]
    if {[string compare $last none]} {
	for {set i 0} {$i <= $last} {incr i} {
	    if {$xd_tk_major >=4} {
		if {[string compare [$w type $i] cascade]==0} {
		    destroy [$w entrycget $i -menu]
		}
	    } else {
		set c [lindex [$w entryconfig $i -menu] 4]
		if {[string compare $c ""]} {
		    destroy $c
		}
	    }
	}
	$w delete 0 last
    }

    foreach set [dataset] {
	add_object_entry $w $set dataset
	foreach obj [$set xydiag] {
	    add_object_entry $w $obj xydiagram
	}
	foreach obj [$set molecule] {
	    add_object_entry $w $obj molecule
	}
	foreach obj [$set path] {
	    add_object_entry $w $obj path
	}
	foreach obj [$set contour] {
	    add_object_entry $w $obj contour
	}
	foreach obj [$set relief] {
	    add_object_entry $w $obj relief
	}
	foreach obj [$set height] {
	    add_object_entry $w $obj heightfield
	}
	foreach obj [$set iso] {
	    add_object_entry $w $obj isosurface
	}
    }
}
