#
# $Header: /scratch/fock/cvsroot/xd/xdgraph/tcl/podBox.tcl,v 1.5 1996/11/07 10:47:38 richter Rel $
#
#
# $Log: podBox.tcl,v $
# Revision 1.5  1996/11/07 10:47:38  richter
# make podBox work with Tk 3.6 (but it's not nice)
#
# Revision 1.4  1996/11/01  17:51:29  richter
# fixed formatting bugs with short items
#
# Revision 1.3  1996/09/06  12:52:21  richter
# indentation should work now
#
# Revision 1.2  1996/06/23  17:22:54  richter
# *** empty log message ***
#
# Revision 1.1  1996/05/23  07:42:23  richter
# Initial revision
#
#

proc podBox {w file topicName locName} {
    upvar $locName locArray $topicName topics
    global xd_tk_major

    set F [open $file]

    set cutting 1
    set cmd newpar
    set item 0
    set over {0 0}
    set depth 0
    set text ""
    while {[gets $F line] > -1} {
	set c0 [string index $line 0]
	if {$cutting} {
	    if {$c0 != "="} {
		continue
	    }
	    set cutting 0
	}
	if {$line == ""} {
	    if {$text != ""} {
		set start [_podbox.output_pod $w $text $cmd \
			       [lrange $over $depth [expr $depth+1]] $item]
		if {$cmd == "head1" || $cmd == "head2"} {
		    set locArray($text) $start
		    lappend topics $text
		} elseif {$cmd == "item"} {
		    set item 1
		}
		set text ""
	    }
	    set cmd newpar
	    continue
	}
	if {$cmd == "newpar"} {
	    switch -glob -- $line {
		=head1* {
		    set cmd head1
		    set text [string range $line 7 end]
		    set depth 1
		    set over {0 0 4}
		    set item 0
		}
		=head2* {
		    set cmd head2
		    set text [string range $line 7 end]
		    set depth 1
		    set over {0 0 4}
		    set item 0
		}
		=item* {
		    set cmd item
		    set text [string range $line 6 end]
		}
		=over* {
		    set cmd over
		    set text ""
		    if {![regexp -- {[0-9]+} [string range $line 6 end] oinc]} {
			set oinc 4
		    }
		    incr depth
		    set nover [lindex $over $depth]
		    incr nover $oinc
		    lappend over $nover
		    set item 0
		}
		=back* {
		    set cmd back
		    set text ""
		    set over [lrange $over 0 $depth]
		    incr depth -1 
		    set item 0
		}
		=cut* {
		    set cmd newpar
		    set cutting 1
		    set item 0
		}
		=pod* {
		    set cmd newpar
		    set cutting 0
		}
		{[ \t]*} {
		    set cmd verbatime
		    _podbox.output_verbatime $w $line [lrange $over $depth [expr $depth+1]] 1
		    set item 0
		}
		default {
		    set cmd fill
		    set text $line
		}
	    }
	    continue
	}
	if {$cmd == "verbatime"} {
	    _podbox.output_verbatime $w $line [lrange $over $depth [expr $depth+1]] 0
	} else {
	    append text " $line"
	}
    }
    if {$text != ""} {
	_podbox.output_pod $w $text $cmd [lrange $over $depth [expr $depth+1]] $item
    }


    close $F

    if {$xd_tk_major >= 4} {
	$w tag configure head1 -spacing1 4m -spacing3 2m \
	    -font "-*-Courier-Bold-R-Normal--*-140-*-*-*-*-*-*"
	$w tag configure head2 -spacing1 4m -spacing3 2m \
	    -font "-*-Courier-Bold-R-Normal--*-120-*-*-*-*-*-*"
	$w tag configure verbatime -spacing1 0m -spacing3 0m
	$w tag configure itemtag -spacing3 0m
	$w tag configure postitemtag -spacing1 0m
    } else {
	$w tag configure head1 -font "-*-Courier-Bold-R-Normal--*-140-*-*-*-*-*-*"
	$w tag configure head2 -font "-*-Courier-Bold-R-Normal--*-120-*-*-*-*-*-*"
    }
    $w tag configure Itag -font "-*-Courier-Medium-O-Normal--*-120-*-*-*-*-*-*"
    $w tag configure Btag -font "-*-Courier-Bold-R-Normal--*-120-*-*-*-*-*-*"
    $w tag configure Ctag -underline 1
    $w tag configure Utag -underline 1
    if {$xd_tk_major >= 4} {
	set cf 8
	for {set i 0} {$i < 32} {incr i} {
	    set overtag [format "over%d" $i]
	    set lm2 [format "%dp" [expr $i*$cf]]
	    $w tag configure $overtag -lmargin1 $lm2 -lmargin2 $lm2
	}
	$w configure -wrap word -spacing3 2m -spacing1 2m
    } else {
	$w configure -wrap word
    }
}

proc _podbox.output_verbatime {w text over newline} {
    global xd_tk_major

    if {$newline} {
	set t "\n$text\n"
    } else {
	set t "$text\n"
    }
    if {$xd_tk_major >= 4} {
	set v [$w index end-1chars]
    } else {
	set v [$w index end]
    }
    $w insert end $t
    set b [$w index end-1chars]
    set overtag [format "over%d" [lindex $over 1]]
    $w tag add verbatime $v $b
    $w tag add $overtag $v $b
}

proc _podbox.output_pod {w text cmd overList item} {
    global xd_tk_major

    set spaces "\[ \t\]+"
    if {$cmd == "head1" || $cmd == "item"} {
	set over [lindex $overList 0]
    } else {
	set over [lindex $overList 1]
    }
    if {$over > 32} {
	set over 32
    } elseif {$over < 0} {
	set over 0
    }
    set overtag [format "over%d" $over]
    if {$cmd == "item" && [set l [string length $text]] < 4} {
	set t "$text "
	if {$l < 3} {
	    append t "S<[string range "    " 0 $l]>"
	}
    } else {
	set t "$text\n"
    }
##    puts "$cmd: /$t/"
    if {$xd_tk_major >= 4} {
	set start [$w index end-1chars]
    } else {
	set start [$w index end]
    }
    regsub -all -- {E<([^>]*)>} $t "E\274\\1\276" t
    if {$cmd == "head1" || $cmd == "head2"} {
	set deftag $cmd
    } else {
	set deftag ""
    }
    while {[regexp -- {([^<]*)(.<)([^>]*)>(.*)} $t match pre tag ins t]} {
	if {$pre != ""} {
	    regsub -all -- $spaces $pre " " pre
	    _podbox.insert $w $pre $deftag
	}
	if {$ins != ""} {
	    switch -exact -- $tag {
		I< -
		C< -
		B< {
		    regsub -- {<} $tag "tag" tag
		    _podbox.insert $w $ins $tag
		}
		L< {
		    if {[regexp -- {([^/"]*)/?"([^"]*)"?} $ins match name section]} {
			_podbox.insert $w "the section on "
			_podbox.insert $w $section Utag
			if {$name != ""} {
			    _podbox.insert $w " in the "
			    _podbox.insert $w $name Utag
			    _podbox.insert $w " manpage"
			}
		    } elseif {[regexp -- {([^/]*)/?(.*)} $ins match name entry]} {
			if {$entry != ""} {
			    _podbox.insert $w "the "
			    _podbox.insert $w $entry Utag
			    _podbox.insert $w " entry"
			    if {$name != ""} {
				_podbox.insert $w " in the "
				_podbox.insert $w $name Utag
				_podbox.insert $w " manpage"
			    } else {
				_podbox.insert $w " elsewhere in this document "
			    }
			} else {
			    if {$name != ""} {
				_podbox.insert $w "the "
				_podbox.insert $w $name Utag
				_podbox.insert $w " manpage"
			    }
			}
		    }
		}
		F< {
		    _podbox.insert $w $ins Itag
		}
		X< {}
		default {
		    _podbox.insert $w $ins $deftag
		}
	    }
	}
    }
    if {$t != ""} {
	regsub -all -- $spaces $t " " t
	_podbox.insert $w $t $deftag
    }
    set end [$w index end-1chars]
    $w tag add $overtag $start $end
    if {$cmd == "item"} {
	$w tag add itemtag $start $end
    } elseif {$item} {
	$w tag add postitemtag $start $end
    }
    return $start   
}

proc _podbox.insert {w text {tag ""}} {
    global xd_tk_major

    if {$xd_tk_major >= 4} {
	set v [$w index end-1chars]
    } else {
	set v [$w index end]
    }
    while {[regexp -- "(\[^\274\]*)E\274(\[^\276\]*)\276(.*)" $text match pre entity text]} {
	$w insert end $pre
	$w insert end [_podbox.entity $entity]
    }
    if {$text != ""} {
	$w insert end $text
    }
    set b [$w index end-1chars]
    if {$tag != ""} {
	$w tag add $tag $v $b
    }
}

proc _podbox.entity {e} {
    
    switch -exact $e {
	"amp" { return "&"}
	"lt" { return "<"}
	"gt" { return ">"}
	"quot" { return "\""}
	"Aacute" { return "\xC1"}
	"aacute" { return "\xE1"}
	"Acirc" { return "\xC2"}
	"acirc" { return "\xE2"}
	"AElig" { return "\xC6"}
	"aelig" { return "\xE6"}
	"Agrave" { return "\xC0"}
	"agrave" { return "\xE0"}
	"Aring" { return "\xC5"}
	"aring" { return "\xE5"}
	"Atilde" { return "\xC3"}
	"atilde" { return "\xE3"}
	"Auml" { return "\xC4"}
	"auml" { return "\xE4"}
	"Ccedil" { return "\xC7"}
	"ccedil" { return "\xE7"}
	"Eacute" { return "\xC9"}
	"eacute" { return "\xE9"}
	"Ecirc" { return "\xCA"}
	"ecirc" { return "\xEA"}
	"Egrave" { return "\xC8"}
	"egrave" { return "\xE8"}
	"ETH" { return "\xD0"}
	"eth" { return "\xF0"}
	"Euml" { return "\xCB"}
	"euml" { return "\xEB"}
	"Iacute" { return "\xCD"}
	"iacute" { return "\xED"}
	"Icirc" { return "\xCE"}
	"icirc" { return "\xEE"}
	"Igrave" { return "\xCD"}
	"igrave" { return "\xED"}
	"Iuml" { return "\xCF"}
	"iuml" { return "\xEF"}
	"Ntilde" { return "\xD1"}
	"ntilde" { return "\xF1"}
	"Oacute" { return "\xD3"}
	"oacute" { return "\xF3"}
	"Ocirc" { return "\xD4"}
	"ocirc" { return "\xF4"}
	"Ograve" { return "\xD2"}
	"ograve" { return "\xF2"}
	"Oslash" { return "\xD8"}
	"oslash" { return "\xF8"}
	"Otilde" { return "\xD5"}
	"otilde" { return "\xF5"}
	"Ouml" { return "\xD6"}
	"ouml" { return "\xF6"}
	"szlig" { return "\xDF"}
	"THORN" { return "\xDE"}
	"thorn" { return "\xFE"}
	"Uacute" { return "\xDA"}
	"uacute" { return "\xFA"}
	"Ucirc" { return "\xDB"}
	"ucirc" { return "\xFB"}
	"Ugrave" { return "\xD9"}
	"ugrave" { return "\xF9"}
	"Uuml" { return "\xDC"}
	"uuml" { return "\xFC"}
	"Yacute" { return "\xDD"}
	"yacute" { return "\xFD"}
	"yuml" { return "\xFF"}
	
	"lchevron" { return "\xAB"}
	"rchevron" { return "\xBB"}
    }
}