#
# Copyright (c) 1995 The XD Group, Free University of Berlin. All rights reserved.
#
# $Header: /scratch/fock/cvsroot/xd/xdgraph/tcl/xdGT.tcl,v 2.6 1999/06/03 12:36:27 richter Exp $
#
#
# $Log: xdGT.tcl,v $
# Revision 2.6  1999/06/03 12:36:27  richter
# first throw at removable views
#
# Revision 2.5  1996/11/11 16:45:17  richter
# dump compatibility proc needed an eval
#
# Revision 2.4  1996/11/07  17:10:18  richter
# add FocusIn/FocusOut bindings for Tk 3.*
#
# Revision 2.3  1996/11/07  10:50:31  richter
# added xd_tk_version
#
# Revision 2.2  1996/10/11  12:08:33  richter
# new hardcopy routine implementing a unified interface for gt and tk driver
#
# Revision 2.1  1996/09/06  12:54:48  richter
# better bindings for GLxwin
# variable size for GLxwin
#
# Revision 2.0  1995/05/12  11:54:40  richter
# First semi-public beta release
#
#

scan $tk_version "%d.%d" xd_tk_major xd_tk_minor
if {($xd_tk_major < 3) || (($xd_tk_major == 3) && ($xd_tk_minor < 4))} {
    error "wrong version of Tk loaded ($tk_version): need 3.4 or later"
}
set xd_tk_version "$xd_tk_major.$xd_tk_minor"
#set xd_library /user/richter/src/xd/xdgraph/tcl

source $xd_library/cli.tcl
source $xd_library/gui.tcl

mkGUI

proc GTCreateView {view width height} {
    global glxwin xd_tk_major
    set w [view2widget $view]
    set d [view2display $view]

    toplevel $w
    set glxwin [GLxwin $d -width [winfo pixels $w ${width}c] \
		    -height [winfo pixels $w ${height}c] -handle $view]
    pack $d -expand yes -fill both
    if {$xd_tk_major < 4} {
	bind $w <FocusIn> "getfocus %d $w"
	bind $w <FocusOut> {focus [focus default]}
    }
    bind $w <Control-Up>    "$d rotx -6"
    bind $w <Control-Down>  "$d rotx 6"
    bind $w <Control-Left>  "$d roty -6"
    bind $w <Control-Right> "$d roty 6"
    bind $w <Up>        "$d rotx -30"
    bind $w <Down>      "$d rotx 30"
    bind $w <Left>      "$d roty -30"
    bind $w <Right>     "$d roty 30"
    bind $w <Shift-Up>    "$d rotx -90"
    bind $w <Shift-Down>  "$d rotx 90"
    bind $w <Shift-Left>  "$d roty -90"
    bind $w <Shift-Right> "$d roty 90"
    bind $d <2>         "$d origin %x %y"
    bind $d <B2-Motion> "$d rotate %x %y"
    bind $w <Destroy>   "remove $view"
    tkwait visibility $d
    update
    $d loadfont
}

proc getfocus {d w} {
    if {$d == "NotifyVirtual"} {
	focus $w
    }
}

proc UpdateView {view} {
    set d [view2display $view]
    $d update
}

proc RemoveView {view} {
    set w [view2widget $view]
    if {[winfo exists $w]} {
	destroy $w
    }
}

proc hardcopy {args} {
    global active

    set d [view2display $active(view)]
    set cmd [list $d dump]
    while {[llength $args] >= 2} {
        set option [lindex $args 0]
        set value  [lindex $args 1]
        set args [lreplace $args 0 1]
        switch -glob -- $option {
            -width {
		lappend cmd -width [winfo pixels $d $value]
	    }
	    -height {
		lappend cmd -height [winfo pixels $d $value]
	    }
	    -file {
		lappend cmd -file $value
	    }
	}
    }

    eval $cmd
}

proc dump {args} {
    eval [concat hardcopy $args]
}
