#ifndef lint
static char *rcsid = "$Header: /scratch/fock/cvsroot/xd/xdgraph/src/cmdManager.c,v 2.10 1996/07/25 09:14:52 richter Rel $";
static char *copyright = "Copyright (c) 1995 The XD Group, Free University of Berlin. All rights reserved.";
#endif
/*
 * $Log: cmdManager.c,v $
 * Revision 2.10  1996/07/25 09:14:52  richter
 * new numbers because CV (emacs package) does not unterstand branches
 *
 * Revision 2.9.1.3  1996/07/25  06:20:16  richter
 * cmdSetView takes an array of possible view types
 * view names are lower case by default
 *
 * Revision 2.9.1.2  1996/07/03  14:30:38  richter
 * *** empty log message ***
 *
 * Revision 2.9.1.1  1996/05/20  11:29:53  richter
 * no more slices
 * other changes
 *
 * Revision 2.9  1996/04/09  15:54:28  richter
 * first ci for xdgraph (formerly xd2d)
 *
 * Revision 2.0  1995/05/12  11:54:06  richter
 * First semi-public beta release
 *
 *
 */
/*
 *----------------------------------------------------------------------
 * include files
 *----------------------------------------------------------------------
 */
#include "conf.h"               /* global configuration                 */
#include "xdgraph.h"               /* type definitions and array sizes     */
#include "cmdProto.h"
#include "namProto.h"
#include "setProto.h"
#include "vieProto.h"
#include "strProto.h"

int
cmdAnalyzeName(char *objName,
               char **datName,
               DatasetP *dPtr)
{
    Tcl_CmdInfo cinfo;
    
    if (! Tcl_StringMatch(objName, ":?*:?*")) {
        Tcl_AppendResult(interp, "bad object name syntax, ",
                         "must be \":<dataset>:<object>\"",
                         (char *) NULL);
        return TCL_ERROR;
    }

    if (Tcl_GetCommandInfo(interp, objName, &cinfo)) {
	Tcl_AppendResult(interp, "command \"", objName, "\" already exists",
			 (char *) NULL);
	return TCL_ERROR;
    }

    *datName = setGetName(objName);
    *dPtr = setFindByName(*datName);
    if (! *dPtr) {
        Tcl_AppendResult(interp, "dataset \"", *datName,
                         "\" doesn't exist", (char *) NULL);
        return TCL_ERROR;
    }
    return TCL_OK;
}

int
cmdSetView(Tcl_Interp *interp,
           char **name,
           int nt,
           ViewE type[],
           char *setName,
           char *objName,
           char *objType,
           ViewOptT *vOpt)
{
    ViewP view;
    char *viewName;
    char *viewType = NULL;
    int i;
    
    switch (type[0]) {
    case VIEW_XYDIAG:  viewType = "xydiag"; break;
    case VIEW_CONTOUR: viewType = "contour"; break;
    case VIEW_RELIEF:  viewType = "relief"; break;
    case VIEW_PATH:    viewType = "path"; break;
    case VIEW_HEIGHT:  viewType = "height"; break;
    case VIEW_SURFACE: viewType = "surface"; break;
    default:      viewType = "unknown";
    }

    if (*name == NULL) {
        viewName = viewMakeName(setName, viewType);
        *name = strDupl(viewName);
    }
        
    if (*name) {
        view=viewFindByName(*name, NULL);
        if (!view) {
            int code;
            code = vieAutoCreate(interp, *name, viewType, vOpt);
            if (code != TCL_OK) return code;
            view=viewFindByName(*name, NULL);
            if (! view)  {
                Tcl_AppendResult(interp, "unable to auto create view ",
                                 name, NULL);
                return TCL_ERROR;
            }
        } else {
            for (i=0; i<nt; ++i) {
                if (view->type == type[i]) break;
            }
            if (i >= nt) {
                Tcl_AppendResult(interp, "view ", *name, " has wrong type\n",
                                 NULL);
                return TCL_ERROR;
            }
        }

    }
    viewRegisterObject(view, objName, objType);
    return TCL_OK;
}
