#ifndef XD_CTRTYPES_H
#define XD_CTRTYPES_H
/*
 * Copyright (c) 1995 The XD Group, Free University of Berlin. All rights reserved.
 *
 * $Header: /scratch/fock/cvsroot/xd/xdgraph/src/ctrTypes.h,v 2.11 1996/09/05 15:06:25 richter Rel $
 *
 * $Log: ctrTypes.h,v $
 * Revision 2.11  1996/09/05 15:06:25  richter
 * new 'tag' field (for the display list interface)
 *
 * Revision 2.10  1996/07/25  09:14:52  richter
 * new numbers because CV (emacs package) does not unterstand branches
 *
 * Revision 2.9.1.1  1996/07/25  06:00:06  richter
 * handle vertac
 *
 * Revision 2.9  1996/04/09  16:13:02  richter
 * first ci for xdgraph (formerly xd2d)
 *
 * Revision 2.0  1995/05/12  11:54:18  richter
 * First semi-public beta release
 *
 *
 */

/*
 * Level Structure
 * Describes one contour level.
 */
#define M_LVL_CALC_DONE 0x01	/* level has been calculated		*/
#define M_LVL_PLOT_DONE 0x02	/* level has been drawn			*/
typedef struct levelS *LevelP;
typedef struct levelS {
    int		ns;		/* number of segments (not used)	*/
    int         tag;
    int		flags;
    double	value;		/* value of this contour level		*/
    SegmentP	segments;	/* anchor of segment chain		*/
    LevelP	next;		/* link to next level in the same
				   contour group			*/
} LevelT;

#define M_CTR_IN_USE 0x01
#define M_CTR_HAS_COLORRAMP 0x02
typedef struct contourS *ContourP;
typedef struct contourS {
    char   *name;
    int    flags;
    StyleT style[2];
    int    nl;
    LevelP level;
    double vertac;
    char   *view;
    char   *object;
} ContourT;

#endif
