#ifndef XD_DLTYPES_H
#define XD_DLTYPES_H
/*
 * Copyright (c) 1995 The XD Group, Free University of Berlin. All rights reserved.
 *
 * $Header: /scratch/fock/cvsroot/xd/xdgraph/src/dlTypes.h,v 2.12 1996/09/05 15:08:14 richter Rel $
 *
 * $Log: dlTypes.h,v $
 * Revision 2.12  1996/09/05 15:08:14  richter
 * many changes while completing the display list interface
 *
 * Revision 2.11  1996/07/28  11:48:19  richter
 * DLplaneE types for different drawing planes
 *
 * Revision 2.10  1996/07/25  09:19:15  richter
 * *** empty log message ***
 *
 */

typedef enum {DL_NOOP, DL_SEGMENT, DL_TRIANGLE, DL_RECTANGLE,
              DL_HEIGHTFIELD, DL_SPHERE, DL_CYLINDER, DL_TEXT,
              DL_MARKER} DLobjE;

typedef enum {DL_BG_PLANE, DL_MAIN_PLANE, DL_FG_PLANE} DLplaneE;

typedef struct {
    c3dT vertex[2];
} DLRectangle;

typedef struct {
    c3dT vertex;
    double radius;
} DLSphere;

typedef struct {
    c3dT vertex;
    int marker;
} DLMarker;

typedef struct {
    double radius, height;
    c3dT origin, axis;
    double angle;
} DLCylinder;

typedef struct {
    c3dT vertex;
    char *string;
} DLText;

typedef struct {
    SegmentP v;
} DLSegment;

typedef struct {
    TriangleP head;
} DLTriangle;

typedef struct {
    int nx, ny;
    double xinc, yinc, xorig, yorig;
    double vertac, hcut, lcut;
    unsigned int listid;
    c3dT *vertex;
    c3dT *normal;
    GtColor *color;
} DLHeight;

typedef union {
    void	   *nl;
    DLRectangle	   *Rectangle;
    DLTriangle	   *Triangle;
    DLSphere	   *Sphere;
    DLCylinder	   *Cylinder;
    DLText	   *Text;
    DLSegment	   *Segment;
    DLHeight       *Height;
    DLMarker       *Marker;
} DLobjU;

typedef struct dlobjS *DLobjP;
typedef struct dlobjS {
    DLobjE type;
    int    tag;
    int    done;
    DLobjU object;
    StyleT style;
    DLobjP next, prev;
} DLobjT;

#endif
