#ifndef XD_ISOTYPES_H
#define XD_ISOTYPES_H
/*
 * Copyright (c) 1995 The XD Group, Free University of Berlin. All rights reserved.
 *
 * $Header: /scratch/fock/cvsroot/xd/xdgraph/src/isoTypes.h,v 2.11 1996/09/06 11:21:46 richter Rel $
 *
 * $Log: isoTypes.h,v $
 * Revision 2.11  1996/09/06 11:21:46  richter
 * new 'tag' field (for the display list interface)
 *
 * Revision 2.10  1996/07/25  09:14:52  richter
 * new numbers because CV (emacs package) does not unterstand branches
 *
 * Revision 2.9  1996/04/09  16:13:02  richter
 * first ci for xdgraph (formerly xd2d)
 *
 * Revision 2.0  1995/05/12  11:54:18  richter
 * First semi-public beta release
 *
 *
 */
typedef struct triangleS *TriangleP;
typedef struct triangleS {
    c3dT v1, v2, v3;            /* array, holding the coordinates       */
    c3dT n1, n2, n3;            /* array, holding the coordinates       */
    TriangleP next;             /* link to next chunk                   */
} TriangleT;

/*
 * Surface Structure
 * Describes one isosurface level.
 */
#define M_SRF_CALC_DONE 0x01	/* surface has been calculated		*/
#define M_SRF_PLOT_DONE 0x02	/* surface has been drawn	       	*/
typedef struct surfaceS *SurfaceP;
typedef struct surfaceS {
    int		nt;		/* number of triangles (not used)	*/
    int		flags;
    int         tag;
    double	value;		/* value of this isosurface level      	*/
    double      orig[3];
    TriangleP	triangles;	/* anchor of triangle chain		*/
    TriangleP   tritail;
    SurfaceP	next;		/* link to next surface in the same
				   isosurface group			*/
} SurfaceT;

#define M_ISO_IN_USE 0x01
typedef struct isosurfaceS *IsosurfaceP;
typedef struct isosurfaceS {
    char   *name;
    int    flags;
    StyleT style;
    int    ns;
    SurfaceP surface;
    char   *view;
    char   *object;
} IsosurfaceT;

#endif
