#ifndef lint
static char *rcsid = "$Header: /scratch/fock/cvsroot/xd/xdgraph/src/molManager.c,v 2.16 1997/06/24 10:58:34 richter Rel $";
static char *copyright = "Copyright (c) 1995 The XD Group, Free University of Berlin. All rights reserved.";
#endif
/*
 * $Log: molManager.c,v $
 * Revision 2.16  1997/06/24 10:58:34  richter
 * *** empty log message ***
 *
 * Revision 2.13  1997/06/23 19:18:31  richter
 * added options to suppress atom, bond or label plot
 *
 * Revision 2.12  1996/09/06  11:23:46  richter
 * clean def styles
 * renamed objects to atoms and connex to bonds
 *
 * Revision 2.11  1996/07/28  11:45:44  richter
 * handle new data in MoleculeT
 *
 * Revision 2.10  1996/07/25  09:14:52  richter
 * new numbers because CV (emacs package) does not unterstand branches
 *
 * Revision 2.9.1.1  1996/07/03  14:31:55  richter
 * removed scale; initialize zlimit
 *
 * Revision 2.9  1996/04/09  15:54:28  richter
 * first ci for xdgraph (formerly xd2d)
 *
 * Revision 2.0  1995/05/12  11:54:11  richter
 * First semi-public beta molease
 *
 *
 */
/*
 *----------------------------------------------------------------------
 * include files
 *----------------------------------------------------------------------
 */
#include "conf.h"               /* global configuration                 */
#include "xdgraph.h"		/* type definitions and array sizes     */
#include "molProto.h"
#include "namProto.h"
#include "styProto.h"
#include "strProto.h"

MoleculeP
molAlloc(char *name)
{
    MoleculeP mPtr;

    mPtr = (MoleculeP) ckalloc( sizeof(MoleculeT) );
    if (! mPtr) {
	Tcl_AppendResult(interp, "memory allocation error", NIL);
	return NULL;
    }

    molClean(mPtr, FALSE);
    mPtr->name = strDupl(name);
    if (namAlloc("MOL", name, (void *)mPtr) != TCL_OK) {
        molFree(&mPtr);
        mPtr = NULL;
    }
    
    return(mPtr);
}

void
molClean(MoleculeP mPtr,
	 int old)
{
    if (old) {
	if (mPtr->name) ckfree(mPtr->name);
        if (mPtr->atom_tag) ckfree((char *)mPtr->atom_tag);
        if (mPtr->label_tag) ckfree((char *)mPtr->label_tag);
        if (mPtr->bond_tag) ckfree((char *)mPtr->bond_tag);
	if (mPtr->set)  ckfree(mPtr->set);
        if (mPtr->view) ckfree(mPtr->view);
    }
    
    styClean(&mPtr->def_atom_style, old);
    styClean(&mPtr->def_bond_style, old);
    styClean(&mPtr->def_label_style, old);

    mPtr->name           = NULL;
    mPtr->view           = NULL;
    mPtr->zlimit         = 1.;
    mPtr->atoms          = NULL;
    mPtr->bonds          = NULL;
    mPtr->num_atom_tags  = 0;
    mPtr->num_label_tags = 0;
    mPtr->num_bond_tags  = 0;
    mPtr->atom_tag       = NULL;
    mPtr->label_tag      = NULL;
    mPtr->bond_tag       = NULL;
    mPtr->do_atoms       = TRUE;
    mPtr->do_bonds       = TRUE;
    mPtr->do_labels      = TRUE;
    return;
}

void
molFree(MoleculeP *mol)
{
    MoleculeP mPtr;

    mPtr = *mol;
    if (!mPtr) return;

    namFree("MOL", mPtr->name);
    molClean(mPtr, TRUE);
    ckfree( (char *)mPtr );
    *mol = (MoleculeP) NULL;
    return;
}

int
molListByName(char *match)
{
    return namListByName("MOL", match);
}
