#ifndef lint
static char *rcsid = "$Header: /scratch/fock/cvsroot/xd/xdgraph/src/relManager.c,v 2.11 1996/09/06 11:51:40 richter Rel $";
static char *copyright = "Copyright (c) 1995 The XD Group, Free University of Berlin. All rights reserved.";
#endif
/*
 * $Log: relManager.c,v $
 * Revision 2.11  1996/09/06 11:51:40  richter
 * new 'tag' field (for the display list interface)
 *
 * Revision 2.10  1996/07/25  09:14:52  richter
 * new numbers because CV (emacs package) does not unterstand branches
 *
 * Revision 2.9.1.1  1996/05/19  16:00:48  richter
 * *** empty log message ***
 *
 * Revision 2.9  1996/04/09  15:54:28  richter
 * first ci for xdgraph (formerly xd2d)
 *
 * Revision 2.0  1995/05/12  11:54:11  richter
 * First semi-public beta release
 *
 *
 */
/*
 *----------------------------------------------------------------------
 * include files
 *----------------------------------------------------------------------
 */
#include "conf.h"               /* global configuration                 */
#include "xdgraph.h"		/* type definitions and array sizes     */
#include "relProto.h"
#include "namProto.h"
#include "segProto.h"
#include "styProto.h"
#include "strProto.h"
#include "pltProto.h"

ReliefP
relAlloc(char *name)
{
    ReliefP rPtr;

    rPtr = (ReliefP) ckalloc( sizeof(ReliefT) );
    if (! rPtr) {
	Tcl_AppendResult(interp, "memory allocation error", NIL);
	return NULL;
    }

    relClean(rPtr, FALSE);
    rPtr->name = strDupl(name);
    if (namAlloc("REL", name, (void *)rPtr) != TCL_OK) {
        relFree(&rPtr);
        rPtr = NULL;
    }
    
    return(rPtr);
}

void
relClean(ReliefP rPtr,
	 int old)
{
    styClean(&rPtr->style, old);

    if (old) {
	if (rPtr->name)   ckfree(rPtr->name);
	if (rPtr->seg)    segFree(&rPtr->seg);
	if (rPtr->view)   ckfree(rPtr->view);
	if (rPtr->object) ckfree(rPtr->object);
    }

    rPtr->name =   NULL;
    rPtr->flags =  0;
    rPtr->tag =    0;
    rPtr->nx =     0;
    rPtr->ny =     0;
    rPtr->mode =   3;
    rPtr->eye.x =  1.;
    rPtr->eye.y =  1.;
    rPtr->eye.z =  0.6;
    rPtr->vertac = 1.;
    rPtr->hcut =   1.;
    rPtr->lcut =   -1.;
    rPtr->seg =    NULL;
    rPtr->object = NULL;
    rPtr->view =   NULL;

    return;
}

void
relFree(ReliefP *rel)
{
    ReliefP rPtr;

    rPtr = *rel;
    if (!rPtr) return;

    namFree("REL", rPtr->name);
    relClean(rPtr, TRUE);
    ckfree( (char *)rPtr );
    *rel = (ReliefP) NULL;
    return;
}

int
relListByName(char *match)
{
    return namListByName("REL", match);
}


int
relInfo(Tcl_Interp *interp,
	ReliefP rPtr)
{
    sprintf(buf, "Relief '%s'  Flags: 0x%2.2x",
	    rPtr->name, rPtr->flags);
    Tcl_AppendResult(interp, buf, NIL);
    sprintf(buf, "\tView: '%s'", rPtr->view);
    Tcl_AppendResult(interp, buf, NIL);
    sprintf(buf, "\tObject:  '%s'", rPtr->object);
    Tcl_AppendResult(interp, buf, NIL);
    sprintf(buf, "\tnx, ny:   %d %d", rPtr->nx, rPtr->ny);
    Tcl_AppendResult(interp, buf, NIL);
    sprintf(buf, "\tmode:     %d", rPtr->mode);
    Tcl_AppendResult(interp, buf, NIL);
    sprintf(buf, "\teye:      %g %g %g", rPtr->eye.x,rPtr->eye.y,rPtr->eye.z);
    Tcl_AppendResult(interp, buf, NIL);
    sprintf(buf, "\tvertac:   %g", rPtr->vertac);
    Tcl_AppendResult(interp, buf, NIL);
    sprintf(buf, "\tcutoff:   %g %g", rPtr->hcut, rPtr->lcut);
    return TCL_OK;
}
