#ifndef XD_SETTYPES_H
#define XD_SETTYPES_H
/*
 * Copyright (c) 1995 The XD Group, Free University of Berlin. All rights reserved.
 *
 * $Header: /scratch/fock/cvsroot/xd/xdgraph/src/setTypes.h,v 2.11 1996/11/05 17:24:52 richter Rel $
 *
 * $Log: setTypes.h,v $
 * Revision 2.11  1996/11/05 17:24:52  richter
 * added nvar
 *
 * Revision 2.10  1996/07/25  09:14:52  richter
 * new numbers because CV (emacs package) does not unterstand branches
 *
 * Revision 2.9.1.3  1996/07/03  14:29:53  richter
 * no cell for slices
 *
 * Revision 2.9.1.2  1996/07/03  10:08:46  richter
 * removed scale from dataset
 *
 * Revision 2.9.1.1  1996/05/19  16:07:35  richter
 * new set types
 *
 * Revision 2.9  1996/04/09  16:13:02  richter
 * first ci for xdgraph (formerly xd2d)
 *
 * Revision 2.0  1995/05/12  11:54:28  richter
 * First semi-public beta release
 *
 *
 */

typedef enum {DSET_UNKNOWN, DSET_GRID, DSET_FOUR, DSET_PATH,
              DSET_SLICE, DSET_DATA } DsetE;

typedef struct {
    GridT grid;
    ObjectT objects;
    ConnT connex;
} DsetGrid;

typedef struct {
    GridT grid;
    CellT cell;
    ObjectT objects;
    ConnT connex;
} DsetFour;

typedef struct {
    GridT grid;
    ObjectT objects;
    ConnT connex;
    double xmin, xmax, ymin, ymax, zmin, zmax;
    PathdataP    path;
} DsetPath;

typedef struct {
    char *source;
    double axes[3][3];
    double orig[3];
    int    np[3];
    double min[3];
    double max[3];
    GridT  grid;
    ObjectT objects;
    ConnT connex;
} DsetSlice;

typedef struct {
    int np, nvar;
    char *nam[8];
    double *val[8];
    double min[8], max[8];
} DsetData;

#define M_DSET_IN_USE 0x01
typedef struct datasetS *DatasetP;
typedef struct datasetS {
    char     *name;		/* dataset command name		*/
    char     *compid;		/* compound ID			*/
    char     *prop;		/* property			*/
    char     *title;		/* title			*/
    int	     flags;
    double   xsize, ysize;
    DsetE    type;
    union {
        void     *nl;
        DsetGrid *dg;
        DsetFour *df;
        DsetPath *dp;
        DsetSlice *ds;
        DsetData *dd;
    } data;
} DatasetT;

#endif
