#ifndef lint
static char *rcsid = "$Header: /scratch/fock/cvsroot/xd/xdgraph/src/strManager.c,v 2.10 1996/07/25 09:14:52 richter Rel $";
static char *copyright = "Copyright (c) 1995 The XD Group, Free University of Berlin. All rights reserved.";
#endif


/*
 * $Log: strManager.c,v $
 * Revision 2.10  1996/07/25 09:14:52  richter
 * new numbers because CV (emacs package) does not unterstand branches
 *
 * Revision 2.9  1996/04/09  15:54:28  richter
 * first ci for xdgraph (formerly xd2d)
 *
 * Revision 2.0  1995/05/12  11:54:03  richter
 * First semi-public beta release
 *
 *
 */

#include "conf.h"               /* global configuration                 */
#include "xdgraph.h"		/* type definitions and array sizes     */
#include "strProto.h"

char *strDupl(char *s)
{
    size_t len;
    char *t, *p;

    if (s == (char *)NULL) return (char *)NULL;
    /*
     * get string length
     */
    p   = s;
    len = 0;
    while (*p++) len += 1;

    /*
     * allocate new string
     */
    t = p = ckalloc(len+1);

    /*
     * copy string and add NUL terminator
     */
    while (*s) *p++ = *s++;
    *p = '\0';

    /*
     * return result
     */
    return t;
}


char *strDuplOver(char *t, char *s)
{
    if (t) ckfree(t);
    return t=strDupl(s);
}

int strEQ(char *s,
	  char *match,
	  size_t minlen)
{
    static char *string = NIL;
    static size_t length;

    if (s != NULL) {
	string = strDuplOver(string,s);
	length = strlen(string);
    }

    if (length < minlen) return 0;

    return (strncmp(string,match,length) == 0);
}
