#ifndef lint
static char *rcsid = "$Header: /scratch/fock/cvsroot/xd/xdgraph/src/xydManager.c,v 2.12 1996/11/06 11:00:16 richter Rel $";
static char *copyright = "Copyright (c) 1995 The XD Group, Free University of Berlin. All rights reserved.";
#endif
/*
 * $Log: xydManager.c,v $
 * Revision 2.12  1996/11/06 11:00:16  richter
 * (xydAxisClean): clean style for axis
 *
 * Revision 2.11  1996/09/06  12:19:07  richter
 * new 'tag' field (for the display list interface)
 * new Axis structure
 *
 * Revision 2.10  1996/07/25  09:14:52  richter
 * new numbers because CV (emacs package) does not unterstand branches
 *
 * Revision 2.9  1996/07/03  14:31:21  richter
 * *** empty log message ***
 *
 * Revision 2.2  1996/05/23  07:56:45  richter
 * *** empty log message ***
 *
 * Revision 2.9  1996/04/09  15:54:28  richter
 * first ci for xdgraph (formerly xd2d)
 *
 * Revision 2.0  1995/05/12  11:54:11  richter
 * First semi-public beta release
 *
 *
 */
/*
 *----------------------------------------------------------------------
 * include files
 *----------------------------------------------------------------------
 */
#include "conf.h"               /* global configuration                 */
#include "xdgraph.h"		/* type definitions and array sizes     */
#include "xydProto.h"
#include "namProto.h"
#include "styProto.h"
#include "strProto.h"
#include "segProto.h"

XydiagP
xydAlloc(char *name)
{
    XydiagP cPtr;

    cPtr = (XydiagP) ckalloc( sizeof(XydiagT) );
    if (! cPtr) {
	Tcl_AppendResult(interp, "memory allocation error", NIL);
	return NULL;
    }

    xydClean(cPtr, FALSE);
    cPtr->name = strDupl(name);
    if (namAlloc("XYD", name, (void *)cPtr) != TCL_OK) {
        xydFree(&cPtr);
        cPtr = NULL;
    }
    
    return(cPtr);
}

void
xydClean(XydiagP cPtr,
	 int old)
{
    styClean(&cPtr->style, old);
    if (old) {
	if (cPtr->name)    ckfree(cPtr->name);
	if (cPtr->object)  ckfree(cPtr->object);
        if (cPtr->view)    ckfree(cPtr->view);
        if (cPtr->points)  segFree(&cPtr->points);
    }

    cPtr->name = NULL;
    cPtr->type = XYD_UNKNOWN;
    cPtr->view = NULL;
    cPtr->object = NULL;
    xydAxisClean(&cPtr->xax, old);
    xydAxisClean(&cPtr->yax, old);
    cPtr->points = NULL;
    cPtr->tag = 0;
    return;
}

void
xydAxisClean(AxisP axPtr,
             int old)
{
    styClean(&axPtr->style, old);
    if (old) {
        if (axPtr->seg) segFree(&axPtr->seg);
        if (axPtr->ticlab) ckfree((char *)axPtr->ticlab);
        if (axPtr->ticcrd) ckfree((char *)axPtr->ticcrd);
        if (axPtr->tictag) ckfree((char *)axPtr->tictag);
    }
    axPtr->min = 0.;
    axPtr->max = 0.;
    axPtr->step = 0.;
    axPtr->ns = 0;
    axPtr->seg = NULL;
    axPtr->segtag = 0;
    axPtr->ticlab = NULL;
    axPtr->ticcrd = NULL;
    axPtr->tictag = NULL;
    return;
}

void
xydFree(XydiagP *xyd)
{
    XydiagP cPtr;

    cPtr = *xyd;
    if (!cPtr) return;

    namFree("XYD", cPtr->name);
    xydClean(cPtr, TRUE);
    ckfree( (char *)cPtr );
    *xyd = (XydiagP) NULL;
    return;
}

int
xydListByName(char *match)
{
    return namListByName("XYD", match);
}
