#ifndef XD_XYDTYPES_H
#define XD_XYDTYPES_H
/*
 * Copyright (c) 1995 The XD Group, Free University of Berlin. All rights reserved.
 *
 * $Header: /scratch/fock/cvsroot/xd/xdgraph/src/xydTypes.h,v 2.13 1996/11/06 11:02:41 richter Rel $
 *
 * $Log: xydTypes.h,v $
 * Revision 2.13  1996/11/06 11:02:41  richter
 * each axis has its own style now
 *
 * Revision 2.12  1996/11/05  17:20:08  richter
 * added indices xidx and yidx
 *
 * Revision 2.11  1996/09/06  12:01:25  richter
 * new 'tag' field (for the display list interface)
 * new Axis structure
 *
 * Revision 2.10  1996/07/25  09:14:52  richter
 * new numbers because CV (emacs package) does not unterstand branches
 *
 * Revision 2.9  1996/05/20  11:32:48  richter
 * *** empty log message ***
 *
 * Revision 2.9  1996/04/09  16:13:02  richter
 * first ci for xdgraph (formerly xd2d)
 *
 * Revision 2.0  1995/05/12  11:54:28  richter
 * First semi-public beta release
 *
 *
 */

typedef enum {XYD_UNKNOWN, XYD_POINTS, XYD_LINES} XydiagE;

typedef struct axisS *AxisP;
typedef struct axisS {
    StyleT style;
    double min, max, step;
    int ns;
    SegmentP seg;
    int segtag;
    char **ticlab;
    c3dT *ticcrd;
    int *tictag;
} AxisT;

typedef struct xydiagS *XydiagP;
typedef struct xydiagS {
    char     *name;
    XydiagE   type;
    StyleT   style;
    char     *view;
    char     *object;
    int      xidx, yidx;
    AxisT    xax, yax;
    SegmentP points;
    int tag;
} XydiagT;

#endif
